/* SetiHAMM.cpp : This program quite simple collect the SETI@home projekt result
 				  in a data directory.

	BeR, 1999

Changes:
    27.11.2000: Collect the final "state.sah" files & datas too...
	01.04.2000: The new version collect the new SETI version's "result.sah" files.

************************************************************************************/

#include "io.h"
#include <conio.h>
#include "direct.h"
#include "fcntl.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "sys/stat.h"
#include "sys/types.h"

/*--------------------------------*/
void SaveSAH(char *sfile);
void _kilep( void *_mem, int _ki );
/*--------------------------------*/
struct _finddata_t ffr;
struct _stat buf;
char _ofname[100],
	 _ResType[]="operation=send_result_get_user_stats";
/*--------------------------------*/

int main(int argc, char* argv[]) {

	printf("Hello, I am a SETI-hamster :-)))!\n\n");

	if (argc > 1) {
		printf("Please let me run, I'd collect the actual SETI@home result & the final state...\n\n"
			   "I don't speak and don't unterstand any human language, I can't help to You,\n"
			   "but I know, what can I do with your SETI result.sah & state.sah (v2.x file), if it is exist\n"
			   "in the working diectory, and there is exist a data directory to my work...\n\n"
			   "Bye!\n\n");
		exit(-666);
		}

	SaveSAH("result.sah");
	SaveSAH("state.sah");

//	while(!_kbhit());
	return(0);

}

/*--------------------------------*/

void SaveSAH(char *sfile) {
	int fi,fh,result;
	static time_t _R_time=0;
	char *mp;

	fi=_findfirst(sfile, &ffr);

	if ( fi == -1L ) {
		printf("I was not found the result.sah, there is a SETI@home working directory?\n"
			   "If it is, the client is working or sleeping...\n");
		_kilep((void *)NULL, -1);
		}

	if( (fh = _open( sfile, _O_BINARY )) ==  -1 ) {
		printf("Can't open the %s, how can I work with it ...?\n\n", sfile);
		_kilep((void *)NULL, -2);
		}

	result = _fstat( fh, &buf );
	if ( result != 0 ) {
		_close(fh);
		printf("There is a problem with %s, I can't work with it...\n\n", sfile);
		_kilep((void *)NULL, -3);
		}

	mp=(char *)calloc(buf.st_size,1);
	if ( mp == NULL ) {
		_close(fh);
		printf("There is not enough memory!\n\n");
		_kilep((void *)NULL, -4);
		}

	fi = _read(fh, mp, buf.st_size);
	_close(fh);

	if ( buf.st_size != fi ) {
		printf("There is a problem during read process from %s!\n\n", sfile);
		_kilep(mp, -5);
		}

	if ( sfile[0] == 'r' ) {
		_R_time=buf.st_ctime;
		if ( strncmp(mp,_ResType,sizeof(_ResType)-1)!=0 ) {
			_close(fh);
			printf("This result.sah is not a SETI@home type file!\n\n");
			_kilep(mp, -6);
			}
		}

	if ( chdir("data") ) {
		printf("Can't open the data directory, why?\n"
			"Please create it, and run me again!\n\n");
		_close(fh);
		_kilep(mp, -7);
		}

	sprintf(_ofname, "%c_%d.sah", sfile[0], _R_time);
	if ( (fh=_open(_ofname, _O_RDWR | _O_TRUNC | _O_CREAT | _O_BINARY)) == -1 ) {
		printf("Can't create a new datafile in the data directory...\n");
		chdir("..");
		_close(fh);
		_kilep(mp, -8);
		}
	fi = _write(fh, mp, buf.st_size);
	_close(fh);

	if ( buf.st_size != fi ) {
		printf("There is a problem during write process to %s!\n\n",_ofname);
		chdir("..");
		_close(fh);
		_kilep(mp, -9);
		}

	chdir("..");
	_close(fh);
	free(mp);
}

/*--------------------------------*/

void _kilep( void *_mem, int _ki ){
	if ( _mem != NULL )
		free(_mem);
	exit (_ki);
}